/*
  This program interprets Language-Hw7 by using Antlr
  to parse infix expressions into an abstract syntax tree,
  and then using your original interpreter for Lnguage-Hw4
  to interpret the AST.
*/
import org.antlr.runtime.*;
import org.antlr.runtime.tree.*;

public class TestInterpreter
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
        "Program{if (1+1==2) 3 else 4}",

        "Program{if (1<0) 5 else 6}",

        "Program{{var b=true; if (b) -1>0 else 0!=1}}",

        "Program{{var i=5;while(i>0){print(i); i=i-1}}}",

        "Program{{var n=1;var sum=0;while(n<5){sum=sum+n;n=n+1;print(n);print(sum)};sum}}",

        "Program{def g(){1+2+3+4+5+6}; g()}",  // g is a function that has no paramerters

        "Program{def f(x,y,z){x+y+z}; f(5,6,7)}",

        "Program{ ((x)->x * x)(5) }",

        "Program{ (()->2 + 2)() }",  // this anonymous function has no parameters

        "Program{ ((u,v)->u + v)(3,4) }",

        "Program{def x=20; {var x=10; ((z)->z + x)(5)}}"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         LanguageHw7_ASTLexer  lexer  = new LanguageHw7_ASTLexer(new ANTLRStringStream(exprs[i]));
         LanguageHw7_ASTParser parser = new LanguageHw7_ASTParser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            // The result from this parse is a tree.
            LanguageHw7_ASTParser.prog_return r = parser.prog();

            // Convert Antlr's AST to a string.
            String s = ((CommonTree)(r.getTree())).toStringTree();
            System.out.println( s );

/* Uncomment this part after you get the AST grammar working
            // prep the string for our stupid tokenizer
            String newS = "";
            for (int j = 0; j < s.length(); j++)
            {
               char c = s.charAt(j);
               if (c == '(')
               {
                  newS += "( "; // put spaces after ('s
               }
               else if (c == ')')
               {
                  newS += " )"; // put spaces before )'s
               }
               else
               {
                  newS += c;
               }
            }
            newS = newS.toLowerCase();
            System.out.println( newS );

            // Use the new string to build one of our AST's.
            Tree ast = BuildTree.buildTree( newS );
            // pretty-print the abstract syntax tree
            System.out.println( PrettyPrinter.prettyPrint( ast ) + "\n" );
            // print the infix version of the expression
            System.out.println( AST2infix.ast2infix( ast ) + "\n" );
            // evaluate the expression (interpret the AST)
            Value value = Evaluate.evaluate( ast );
            // print out the result
            System.out.println( "result = " + value );
*/
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println("=============================================");
      }
   }//main

}//TestInterpreter
