/*
  This program parses Language-Hw7 expressions.

  Use this program to test your parser before
  starting to add AST constructing actions to it.
*/
import org.antlr.runtime.*;


public class TestParser
{
   public static void main(String[] args)
   {
      String[] exprs =
      {
        "Program{if (1+1==2) 3 else 4}",

        "Program{if (1<0) 5 else 6}",

        "Program{{var b=true; if (b) -1>0 else 0!=1}}",

        "Program{{var i=5;while(i>0){print(i); i=i-1}}}",

        "Program{{var n=1;var sum=0;while(n<5){sum=sum+n;n=n+1;print(n);print(sum)};sum}}",

        "Program{def g(){1+2+3+4+5+6}; g()}",  // g is a function that has no paramerters

        "Program{def f(x,y,z){x+y+z}; f(5,6,7)}",

        "Program{ ((x)->x * x)(5) }",

        "Program{ (()->2 + 2)() }",  // this anonymous function has no parameters

        "Program{ ((u,v)->u + v)(3,4) }",

        "Program{def x=20; {var x=10; ((z)->z + x)(5)}}"
      };

      for (int i = 0; i < exprs.length; i++)
      {
         LanguageHw7Lexer  lexer  = new LanguageHw7Lexer(new ANTLRStringStream(exprs[i]));
         LanguageHw7Parser parser = new LanguageHw7Parser(new CommonTokenStream(lexer));

         System.out.println( "Parsing: " + exprs[i] );
         try
         {
            parser.prog();
         }
         catch (Exception e)
         {
            System.out.println(e);
         }
         System.out.println("=============================================");
      }
   }//main

}//TestParser
